clc;clear;
tic
 

eco.theta           = .15;
eco.sigma           = 1.00;     % log case
eco.beta            = 0.7;
eco.lbar            = 0.3;      %labor supply when unproductive
eco.alpha           = 0.8;      % 
eco.rho             = 0.8;      % Quarterly value 0.75
eco.phi             = 0.9;      % productivity scale when excluded
%eco.BG              = 0.0;
eco.BG              = -0.06;

ls                  = (1 - eco.alpha)/(1/eco.beta - eco.alpha);

eco.Uc              = @(c) c.^-eco.sigma;
eco.Ucinv           = @(c) c.^(-1/eco.sigma);
if eco.sigma == 1
    eco.U           = @(c) log(c);
else
    eco.U           = @(c) (c.^(1-eco.sigma)-1)/(1-eco.sigma);
end


%%
%%%%%%%%%%% D=2 no debt
testq               = 1;
q                   = 0.9;
while abs(testq)>10^-6

    B0              = 0;
   

    test            =1;
    while abs(test)>10^-6
        D2          = funcD2e(eco,q,B0,false,0);
        test        = (D2.We - D2.V10b);
        B0          = B0 + 0.1*test;
    end;

    testq   = D2.FM;
    q       = q +0.5*testq;
end
D2
qs2         = q;

%pause


%%%%%%%%%%%   D=3 no debt
testq               = 1;
q                   = 0.9;
while abs(testq)>10^-6

    B0              = 0;
   

    test            =1;
    while abs(test)>10^-6
        D3          = funcD3e(eco,q,B0,false,0);
        test        = (D3.We - D3.V20b);
        B0          = B0 + 0.1*test;
    end;

    testq   = D3.FM;
    q       = q +0.5*testq;
end
D3
qs3         = q;

Wtot        = D3.Wtot;

%%%%%%%%%%%  d=2 financement
testq               = 1;
q                   = 0.9;
while abs(testq)>10^-6

    B0              = 0;
   

    test            =1;
    while abs(test)>10^-6
        D2f          = funcD2e_fin(eco,q,B0,false,eco.BG);
        test        = (D2f.We - D2f.V10b);
        B0          = B0 + 0.1*test;
    end;

    testq   = D2f.FM;
    q       = q +0.5*testq;
end
D2f
qs2f        = q;


%%%%%%%%%%%   D=3 debt
testq               = 1;
q                   = 0.9;
while abs(testq)>10^-6

    B0              = 0;
   

    test            =1;
    while abs(test)>10^-6
        D3f          = funcD3e(eco,q,B0,false,eco.BG);
        test        = (D3f.We - D3f.V20b);
        B0          = B0 + 0.1*test;
    end;

    testq   = D3f.FM;
    q       = q +0.5*testq;
end
D3f
qs3f         = q;

Wtot        = D3.Wtot;


%%
%%%%%%%%%%%    computing suply and demand curves    %%%%%%%%%%%%%%%%%


qv              = [max(qs2,qs3)*0.85:0.001:max(qs2,qs3)*1.1];
res             = zeros(length(qv),9);
for i=1:length(qv)
    q   = qv(i);
    B0  = 0;
    test            =1;
    while abs(test)>10^-8
        D2          = funcD2e(eco,q,B0,false,0);
        test        = (D2.We - D2.V10b);
        B0          = B0 + 0.1*test;
    end;
    
    res(i,1) = D2.B0;
    res(i,2) = - (1-eco.alpha)*(1-eco.rho)*D2.B1;
    res(i,3) = D2.V00;
    res(i,4) = D2.exist;
       
    B0  = 0;
    test            =1;
    while abs(test)>10^-8
       D3          = funcD3e(eco,q,B0,false,0);
       test        = (D3.We - D3.V20b);
       B0          = B0 + 0.1*test;
   end;
   
  
   
    res(i,5) = D3.B0 + (1-eco.alpha)*max(D3.B1,0);
    res(i,6) = - (1-eco.alpha)*(1-eco.rho)*eco.rho*D3.B2  - (1-eco.alpha)*min(D3.B1,0);
    res(i,7) = D3.V00;
    res(i,8) = D3.exist; 
   
   
     B0  = 0;
    test            =1;
    while abs(test)>10^-8
       D2f          = funcD2e_fin(eco,q,B0,false,eco.BG);
       test        = (D2f.We - D2f.V10b);
       B0          = B0 + 0.1*test;
   end;
   
 
   
    res(i,9) = D2f.B0;
    res(i,10) = - (1-eco.alpha)*(1-eco.rho)*D2f.B1;
    res(i,11) = D2f.V00;
    res(i,12) = D2f.exist; 
    
    
    
    B0  = 0;
    test            =1;
    while abs(test)>10^-8
       D3f          = funcD3e_fin(eco,q,B0,false,eco.BG);
       test        = (D3f.We - D3f.V20b);
       B0          = B0 + 0.1*test;
   end;
   
    res(i,13) = D3f.B0 + (1-eco.alpha)*max(D3f.B1,0);
    res(i,14) = - (1-eco.alpha)*(1-eco.rho)*eco.rho*D3f.B2  - (1-eco.alpha)*min(D3f.B1,0);
    res(i,15) = D3f.V00;
    res(i,16) = D3f.exist; 
    
    res(i,17) = q;
    
    
end;
%
qt1     = qv(max(find((res(:,7)-res(:,3))>0)));
qex3    = qv(max(find((res(:,8))>0.5)));

qt1f     = qv(max(find((res(:,15)-res(:,11))>0)));
qex3f    = qv(max(find((res(:,12))>0.5)));


% qt2     = qv(max(find((res(:,11)-res(:,7))>0)));
% qex4    = qv(max(find((res(:,12))>0.5)));


%%

close all;
figure(1);
subplot(2,2,1);
plot(res(:,17),res(:,3)); 
hold on;
plot(res(:,17),res(:,7),'r');

subplot(2,2,2);
plot(res(:,17),res(:,4)+0.5); 
hold on;
plot(res(:,17),res(:,8)+1,'r');

%OK if qs3<qt and qs3<qex3 (D3 exits and is higher than D2

subplot(2,2,3);
plot(res(:,17),res(:,1)); 
hold on;plot(res(:,17),res(:,2),'r'); % demand (borrowers)

subplot(2,2,4);
plot(res(:,17),res(:,5)); 
hold on;plot(res(:,17),res(:,6),'r');% demand

%%

figure(2);

qf1          = min(qex3,qt1);
%qf2          = min(qex4,qt2);

istart      = max(find(qv<0.87));
iend        = max(find(qv<0.95));
iff1         = max(find(qv<qf1));
%iff2         = max(find(qv<qf2));

%Su      = [res(istart:iff2,9); res(iff2+1:iff1,5);res(iff1+1:iend,1)];
%De      = [res(istart:iff2,10);res(iff2+1:iff1,6);res(iff1+1:iend,2)];

Su      = [res(istart:iff1,5);res(iff1+1:iend,1)];
Suf     = [res(istart:iff1,13);res(iff1+1:iend,9)];

De      = [res(istart:iff1,6);res(iff1+1:iend,2)];
Def     = [res(istart:iff1,14);res(iff1+1:iend,10)];



% supply of funds

% plot(res(istart:iff,9),res(istart:iff,5),'b'); 
% hold on;
% plot(res(iff+1:iend,9),res(iff+1:iend,1),'b'); 
% % demand of funds
% plot(res(istart:iff,9),res(istart:iff,6),'r'); 
% hold on;
% plot(res(iff+1:iend,9),res(iff+1:iend,2),'r'); 
%    

plot(res(istart:iend,17),De,'-b'); 
hold on;
plot(res(istart:iend,17),Su,'.-.r'); 

XX = res(istart:iend,17);
save FLG_fig1 XX De Su


%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Here Higher public debt  without financing %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


figure(3);

%eco.BG      =  - 0.04;
%BGt          = eco.BG;
De2          = De - eco.BG;




plot(res(istart:iend,17),De2,'-b'); 
hold on;
plot(res(istart:iend,17),Su,'.-.r'); 
XX = res(istart:iend,17);
save FLG_fig2 XX De2 Su

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Here Higher public debt  with financing %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


figure(4);
plot(res(istart:iend,17),De2,'-b'); 
hold on;
plot(res(istart:iend,17),Suf,'.-.r'); 
XX = res(istart:iend,17);
save FLG_fig3 XX De2 Suf

%% Computing welfare difference
testq               = 1;
q                   = 0.9;
while abs(testq)>10^-6

    B0              = 0;
   

    test            =1;
    while abs(test)>10^-6
        D3          = funcD3e(eco,q,B0,false,eco.BG);
        test        = (D3.We - D3.V20b);
        B0          = B0 + 0.1*test;
    end;

    testq   = D3.FM;
    q       = q +0.5*testq;
end
D3
qs3BG         = q;
D3            = funcD3e(eco,q,B0,false,eco.BG);
WtotBG        = D3.Wtot;


% Add is the additional amount of good in the economy, DW is the increase
% in wealth
Add             = (1/qs3BG-1)*(-eco.BG);
DW              = WtotBG -Wtot;

%%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Here positive proba to re-enter %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% 
eco.theta           = .02;
eco.sigma           = 1.00;     % log case
eco.beta            = 0.7;
eco.lbar            = 0.3;      %labor supply when unproductive
eco.alpha           = 0.8;      % 
eco.rho             = 0.8;      % Quarterly value 0.75
eco.phi             = 0.9;      % productivity scale when excluded
%eco.BG              = 0.0;
eco.BG              = -0.06;

ls                  = (1 - eco.alpha)/(1/eco.beta - eco.alpha);
%eco.lbar            = 0.9;

eco.Uc              = @(c) c.^-eco.sigma;
eco.Ucinv           = @(c) c.^(-1/eco.sigma);
if eco.sigma == 1
    eco.U           = @(c) log(c);
else
    eco.U           = @(c) (c.^(1-eco.sigma)-1)/(1-eco.sigma);
end





theta           = eco.theta; 
alpha           = eco.alpha; 
rho             = eco.rho; 
D               = 3;
lambda          = (1-rho)*rho^(D-1)/( 1 - rho^(D-1));


TT              = [alpha,1-rho,alpha*theta,(1-rho)*theta;
                    1-alpha,rho - lambda,0,0;
                    0,0,alpha*(1-theta),(1-rho)*(1-theta);
                    0,lambda,1-alpha,rho];
                
Si              = (TT^1000)*(ones(4,1)/4);     



%%%%%%% computing supply and demand functions
qv              = [0.85:0.001:0.95];
res             = zeros(length(qv),9);

for i=1:length(qv)
    q   = qv(i);
    B0  = 0;
    test            =1;
    while abs(test)>10^-8
        D2          = funcD2enter(eco,q,B0,false,0);
        test        = (D2.We - D2.V10b);
        B0          = B0 + 0.1*test;
    end;
    
    resent(i,1) = D2.B0;
    resent(i,2) = - (1-eco.alpha)*(1-eco.rho)*D2.B1;
    resent(i,3) = D2.V00;
    resent(i,4) = D2.exist;
       
    B0  = 0;
    test            =1;
    while abs(test)>10^-8
       D3          = funcD3enter(eco,q,B0,false,0);
       test        = (D3.We - D3.V20b);
       B0          = B0 + 0.1*test;
   end;
   
  
   
    resent(i,5) = D3.B0 + (1-eco.alpha)*max(D3.B1,0);
    resent(i,6) = - (1-eco.alpha)*(1-eco.rho)*eco.rho*D3.B2  - (1-eco.alpha)*min(D3.B1,0);
    resent(i,7) = D3.V00;
    resent(i,8) = D3.exist; 
   
   
   
    resent(i,9) = q;
    
end;





%
figure(5);


qt1     = qv(max(find((resent(:,7)-resent(:,3))>0)));
qex3    = qv(min(find(resent(:,8)<0.5)));
qf1          = min(qex3,qt1);
%qf2          = min(qex4,qt2);

istart      = max(find(qv<0.87));
iend        = max(find(qv<0.95));
iff1        = max(find(qv<qf1));
%iff2         = max(find(qv<qf2));

%Su      = [res(istart:iff2,9); res(iff2+1:iff1,5);res(iff1+1:iend,1)];
%De      = [res(istart:iff2,10);res(iff2+1:iff1,6);res(iff1+1:iend,2)];

Su      = [resent(istart:iff1,5);resent(iff1+1:iend,1)];
De      = [resent(istart:iff1,6);resent(iff1+1:iend,2)];




% supply of funds

% plot(res(istart:iff,9),res(istart:iff,5),'b'); 
% hold on;
% plot(res(iff+1:iend,9),res(iff+1:iend,1),'b'); 
% % demand of funds
% plot(res(istart:iff,9),res(istart:iff,6),'r'); 
% hold on;
% plot(res(iff+1:iend,9),res(iff+1:iend,2),'r'); 
%    

plot(resent(istart:iend,9),De,'-b'); 
hold on;
plot(resent(istart:iend,9),Su,'.-.r'); 
toc
XX = resent(istart:iend,9);
save FLG_fig4 XX De Su

